var PageProfile = function() {
  this.el_content = document.getElementById('page_profile');
  this.el_btn_favorite = document.getElementById('page_profile_favorite');
  this.el_btn_recent = document.getElementById('page_profile_recent');
  this.el_projects = document.getElementById('page_profile_projects');
  this.el_btn_up = document.getElementById('page_profile_btn_up');
  this.el_btn_down = document.getElementById('page_profile_btn_down');
  this.el_scroll = document.getElementById('page_profile_scroll');
  this.el_scroll_control = document.getElementById('page_profile_scroll_control');

  this.project_index = 0;
  this.projects = [];
  this.loading = false;
  this.project_type = 'recent';
}

PageProfile.prototype.show = function() {
  show('main_preloader');
  show(this.el_content);
  this.el_projects.innerHTML = '';
  var _this = this;
  Data.getRecentProjects(function(projects) {
    _this.projects = projects;
    _this.project_type = 'recent';
    _this.showAfterLoad();
  });
  onKeyBack = function() {buttons[1].el.onclick()};
}

PageProfile.prototype.showAfterLoad = function() {
  buttons.clear(10);
  buttons[1].down = buttons[2].down = buttons[3].down = buttons[4].down = buttons[5].down = buttons[6].down = buttons[7].down = null;

  var _this = this;
  function fn_btn_click(delta) {
  	if (animated) return;
  	if (_this.project_index == 0 && delta == -1) return;
  	if (_this.project_index+9 >= _this.projects.length && delta == 1) return;
  	
  	buttons.clear(14);
  	_this.project_index += 3*delta;
  	_this.renderProjects();
  	_this.setProjectsBtns();
  	
  	animateY(_this.el_projects, -Math.floor(_this.project_index/3)*SIZES.projects.height);
  	var y = Math.round(Math.ceil(_this.project_index/3) * SIZES.projects.scroll_height / Math.ceil((_this.projects.length-9)/3));
  	if (y < 0) y = 0;
  	animateY(_this.el_scroll, y);
  };
 
  buttons.set(10, this.el_btn_recent, [1,null,11,11, true], function(){
    alert('recent button is pressed');
	_this.project_type = 'recent';
    _this.el_projects.innerHTML = '';
    show('main_preloader');
    Data.getRecentProjects(function(projects) {
      _this.projects = projects;
      hide('main_preloader');
      _this.showProjects();
    });
  });
  buttons.set(11, this.el_btn_favorite, [10,null,null,null, true], function(){
    alert('favorite button is pressed');
	_this.project_type = 'favorite';
    _this.el_projects.innerHTML = '';
    show('main_preloader');
    Data.getFavoriteProjects(function(projects) {
      _this.projects = projects;
      hide('main_preloader');
      _this.showProjects();
    });
  });
  buttons.set(12, this.el_btn_up, [8,null,13,null, true], function(){ fn_btn_click(-1); });
  buttons.set(13, this.el_btn_down, [12,null,null,null, true], function(){ fn_btn_click(1); });
  
  this.showProjects();
  
  hide('main_preloader');
  animated = false;
}

PageProfile.prototype.showProjects = function() {
	this.project_index = 0;
	animateInitY(this.el_projects, 0, 0.5);
	animateInitY(this.el_scroll, 0, 0.5);

	this.renderProjects();
	this.setProjectsBtns();
};

PageProfile.prototype.renderProjects = function() {
  var html = '';
  _this = this;
  if (this.projects.length == 0) {
	if (_this.project_type != 'favorite'){
	  html += '<img src="resource/images/not_recent.png" border="0" width="460" height="242" class="img-profile">';
	}else{
	  html += '<img src="resource/images/not_favorit.png" border="0" width="460" height="242" class="img-profile">';
	}
  }
  else {
	var from = (this.project_index - 3 >= 0) ? this.project_index - 3 : 0;
	var to = (this.project_index + 11 < this.projects.length) ? this.project_index + 11 : this.projects.length - 1;
	for (var i=from; i <= to; i++) {
		html += '<div class="project-min" id="page_profile_project_'+i+'"'+((i - from < 3) ? ' style="margin-top: '+Math.floor(from/3)*SIZES.projects.height+'px"' : '')+'>';
		if (this.projects[i].favorited) html += '<div class="tab"></div>';
		if (this.projects[i].recent) html += '<div class="bul"><div class="bul-l"></div><div class="bul-c">'+this.projects[i].recent+'</div><div class="bul-r"></div><div class="clear"></div></div>';
		if (this.projects[i].seen_count > 0 && this.projects[i].overall_count > 0) html += '<div class="pun" style="background-position:-'+Math.round(SIZES.projects.img_width-this.projects[i].seen_count*SIZES.projects.img_width/this.projects[i].overall_count)+'px 0px;">' + (this.projects[i].seen_count / this.projects[i].overall_count * 100 < 50 ? '<center style="color: white" >' : '<center>' )+this.projects[i].seen_count+'/'+this.projects[i].overall_count+'</center></div>';
		html += '<img src="'+this.projects[i].small_thumbnail+'" width="'+SIZES.projects.img_width+'" height="'+SIZES.projects.img_height+'"><br>'+this.projects[i].title+'</div>';
	}
        this.el_projects.style.height = Math.ceil(this.projects.length/3)*207;
        this.el_scroll_control.style.visibility = this.projects.length < 10 ? 'hidden' : 'visible';
  }
  this.el_projects.innerHTML = html;
};

PageProfile.prototype.setProjectsBtns = function() {
	var els = [];
	for (var i=this.project_index; i < this.projects.length && i < this.project_index+9; i++) {
		els.push('page_profile_project_'+i);
	}
	var _this = this;
        buttons.setGroup(14, els, '3x3', true, function(btn) {
          var delta = btn.k - 14;
          showPage('project', _this.projects[_this.project_index+delta].id);
        });
	
	if (buttons[14]) {
		buttons[14].up=2;
		buttons[1].down = buttons[2].down = buttons[3].down = buttons[4].down = buttons[5].down = buttons[6].down = buttons[7].down = 14;
	}
	if (buttons[15]) {
		buttons[15].up=4;
		buttons[4].down = buttons[5].down = buttons[6].down = buttons[7].down = 15;
	}
	if (buttons[16]) {
		buttons[16].up=4;
		buttons[5].down = buttons[6].down = buttons[7].down = 16;
	}
	
	if (buttons[16]) {
		buttons[16].right = 12;
		buttons[12].left = 16;
	} else if (buttons[15]) {
		buttons[15].right = 12;
		buttons[12].left = 15;
	} else if (buttons[14]) {
		buttons[14].right = 12;
		buttons[12].left = 14;
	}
	if (buttons[19]) {
		buttons[19].right = 12;
	} else if (buttons[18]) {
		buttons[18].right = 12;
	} else if (buttons[17]) {
		buttons[17].right = 12;
	}
	if (buttons[22]) {
		buttons[22].right = 13;
		buttons[13].left = 22;
	} else if (buttons[21]) {
		buttons[21].right = 13;
		buttons[13].left = 21;
	} else if (buttons[20]) {
		buttons[20].right = 13;
		buttons[13].left = 20;
	}
	
        buttons[1].down = 10;
	if (buttons[14]) {
		buttons[14].left = 10;
                buttons[10].right = 14;
                buttons[11].right = 14;
		if (buttons[17]) buttons[17].left = 10;
		if (buttons[20]) {
			buttons[20].left = 11;
			buttons[11].right = 20;
		}
	}

        var _this = this;
        // РґР»СЏ СЃРєСЂРѕР»Р»Р° РІРІРµСЂС… СЃ РїРѕРјРѕС‰СЊСЋ VK_UP СЃРѕР·РґР°С‘Рј РµС‰С‘ 3 РєРЅРѕРїРєРё СЃРІРµСЂС…Сѓ
        if (this.project_index > 0) {
            var up_els = [];
            for (var i = this.project_index - 3; i < this.project_index; i++)
                up_els.push('page_profile_project_' + i);
            buttons.setGroup(23, up_els, '1x3', true, null, function(data) {
                _this.el_btn_up.onclick();
                buttons[data.k - 9].el.onmouseover();
            });
            buttons[14].up = 23; buttons[15].up = 24; buttons[16].up = 25;
        }
        // РґР»СЏ СЃРєСЂРѕР»Р»Р° РІРЅРёР· СЃ РїРѕРјРѕС‰СЊСЋ VK_DOWN СЃРѕР·РґР°С‘Рј РµС‰С‘ 3 РєРЅРѕРїРєРё СЃРЅРёР·Сѓ
        if (this.project_index + 9 < this.projects.length) {
            var down_els = [];
            for (var i = this.project_index + 11; i > this.project_index + 8; i--)
                if (document.getElementById('page_profile_project_' + i)) down_els.push('page_profile_project_' + i);
            buttons.setGroup(26, down_els, '1x3', true, null, function(data) {
                _this.el_btn_down.onclick();
                buttons[data.k - 6].el.onmouseover();
            });
            buttons[20].down = buttons[21].down = buttons[22].down = 26;
            if (buttons[27]) buttons[21].down = buttons[22].down = 27;
            if (buttons[28]) buttons[22].down = 28;
        }
        // РѕР±СЂР°Р±РѕС‚РєР° РєРѕР»РµСЃР° РґР»СЏ magic РїСѓР»СЊС‚Р°
        this.el_projects.onmousewheel = function(e) {
            alert(e.wheelDelta);
            if (e.wheelDelta > 0) { // up
                _this.el_btn_up.onclick();
            }
            else { // down
                _this.el_btn_down.onclick();
            }
        };
};

PageProfile.prototype.hide = function() {
  hide(this.el_content);
}
